import { Observable } from 'rxjs';
import { Action, FeatureStoreConfig, StateOrCallback } from './models';
export declare class FeatureStore<StateType extends object> {
    private stateSource;
    state$: Observable<StateType>;
    get state(): StateType;
    private readonly _featureKey;
    get featureKey(): string;
    private sub;
    private readonly featureId;
    constructor(featureKey: string, initialState: StateType, config?: FeatureStoreConfig);
    setState(stateOrCallback: StateOrCallback<StateType>, name?: string): Action;
    select(): Observable<StateType>;
    select<R>(mapFn: (state: StateType) => R): Observable<R>;
    effect<ProvidedType = void, OriginType extends Observable<ProvidedType> | unknown = Observable<ProvidedType>, ObservableType = OriginType extends Observable<infer A> ? A : never, ReturnType = ProvidedType | ObservableType extends void ? () => void : (observableOrValue: ObservableType | Observable<ObservableType>) => void>(effectFn: (origin$: OriginType) => Observable<unknown>): ReturnType;
    undo(action: Action): void;
    destroy(): void;
    ngOnDestroy(): void;
}
export declare function createFeatureStore<T extends object>(featureKey: string, initialState: T, config?: FeatureStoreConfig): FeatureStore<T>;
