import { Observable } from 'rxjs';
import { Action, Actions, AppState, HasEffectMetadata, MetaReducer, Reducer, StoreConfig, StoreExtension } from './models';
declare class StoreCore {
    private actionsSource;
    actions$: Actions;
    private stateSource;
    state$: Observable<AppState>;
    private combineReducersFn;
    private reducerStateSource;
    private get reducerState();
    private get featureReducers();
    private set featureReducers(value);
    private extensions;
    constructor();
    config(config?: Partial<StoreConfig<AppState>>): void;
    addFeature<StateType>(featureKey: string, reducer: Reducer<StateType>, config?: {
        metaReducers?: MetaReducer<StateType>[];
        initialState?: StateType;
        multi?: boolean;
    }): string;
    removeFeature(featureKey: string): void;
    dispatch(action: Action): void;
    updateState(state: AppState): void;
    select<R>(mapFn: (state: AppState) => R): Observable<R>;
    effect(effect$: Observable<any> & HasEffectMetadata): void;
    effect(effect$: Observable<Action>): void;
    addMetaReducers(...reducers: MetaReducer<AppState>[]): void;
    addExtension(extension: StoreExtension): void;
    private addReducer;
    private removeReducer;
}
declare const _default: StoreCore;
/** @internal */
export default _default;
