import { Action, AppState, FeatureConfig, Reducer, StoreConfig } from './models';
import { Observable } from 'rxjs';
export declare class Store {
    private static instance;
    feature<StateType>(featureKey: string, reducer: Reducer<StateType>, config?: FeatureConfig<StateType>): void;
    dispatch: (action: Action) => void;
    select: <R>(mapFn: (state: AppState) => R) => Observable<R>;
    effect: {
        (effect$: Observable<any> & import("./models").HasEffectMetadata): void;
        (effect$: Observable<Action>): void;
    };
    private constructor();
    /** @internal */
    /** @deprecated This is an internal implementation detail, do not use. */
    static configureStore(config: Partial<StoreConfig<AppState>>): Store | never;
}
export declare function configureStore<T>(config: Partial<StoreConfig<T>>): Store;
export declare const actions$: import("./models").Actions;
